﻿// Random gradients
//An InDesign CS3/CS4 JavaScript
// See http://www.milligramme.cc/weblog/2009/09/indesign-47.html
// This is Modified version of script Shake gradient
// Very lot thanks for http://www.milligramme.cc
// Boris Kascheev, www.adobeindesign.ru, boriskasmoscow@gmail.com
main();
function main()
{
	var sel = [];
		if (app.documents.length == 0){
			alert("Please open a document and try again.");
			exit();
		}
		if (app.selection.length != 1) {
			alert ("Please select a one page item with gradiend fill and try again.");
			exit();
		}
		sel=app.activeDocument.selection;
		// отладка alert(sel[0].fillColor.getElements()[0].constructor.name)
		if(sel[0].fillColor.getElements()[0].constructor.name == "Gradient")
		{
			myDialog(sel[0]);
		}
		else
		{
			alert ("Please select a one page item with gradiend fill and try again.");
		}
	
} // main()
	


function myDialog(sel)
{
 var myDialog = app.dialogs.add({name:"RandomGradients: v.1"});
	with(myDialog){
		with(dialogColumns.add()){
			with(borderPanels.add()){
				with(dialogRows.add()){
					staticTexts.add({staticLabel:"Number of Objects"});
				}
				with(dialogRows.add()){
					///staticTexts.add({staticLabel:"Number of Objects"});
					with(dialogColumns.add()){
						staticTexts.add({staticLabel:"in Column:"});
						staticTexts.add({staticLabel:"in Row:"});
					}
					with(dialogColumns.add()){
					var myV= realEditboxes.add({editValue:7});
					var myG= realEditboxes.add({editValue:7});
					}
				}
				with(dialogRows.add()){
					staticTexts.add({staticLabel:"(с) www.adobeindesign.ru"});
				}
			}
		}	// with(dialogColumns.add())
	} //with(myDialog)
 

	 if(myDialog.show() == true){
		var myNumberY = myV.editValue
		var myNumberX = myG.editValue
		myDialog.destroy()
		myRandomGradients(sel, myNumberY, myNumberX)
		
	}
	else {myDialog.destroy()}
} // myDialog

function myRandomGradients(myObj, myNY, myNX)
{
	var newObj, startRandom;
	var myBounds = myObj.geometricBounds
	var myYsize = myBounds[2] - myBounds[0]
	var myXsize = myBounds[3] - myBounds[1]
	var myDiagonal =Math.sqrt(Math.pow(myXsize, 2)+Math.pow(myYsize, 2));
	if(myNY > 1 && myNX > 1)
	{
		for(var j = 0; j < myNX; j++)
		{
			for(var i = 0; i<myNY; i++)
			{
				newobj = myObj.duplicate(undefined, [myXsize*j, myYsize*i])
				// координаты сдублированного объекта
				var newobjX1=newobj.geometricBounds[1];
				var newobjY1=newobj.geometricBounds[0];
				var newobjX2=newobj.geometricBounds[3];
				var newobjY2=newobj.geometricBounds[2];
				newobj.fillColor.type=GradientType.LINEAR;
				newobj.gradientFillLength = myDiagonal;
				startRandom=Math.round(3*Math.random());//
				 switch(startRandom){
						case 0:
						newobj.gradientFillStart=[newobjX1,newobjY2];//
						newobj.gradientFillAngle=90*Math.random(); break;//90°
						case 1:
						newobj.gradientFillStart=[newobjX1,newobjY1];//
						newobj.gradientFillAngle=-90*Math.random(); break;//-90°
						case 2:
						newobj.gradientFillStart=[newobjX2,newobjY1];//
						newobj.gradientFillAngle=-90-90*Math.random(); break;//-90 -180°
						case 3:
						newobj.gradientFillStart=[newobjX2,newobjY2];//
						newobj.gradientFillAngle=90+90*Math.random(); break;//90 180°
				   }
			}
		}

	myObj.remove();
	}
}
